// Playerpausemakegamepause.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"
#include <string>
#include <algorithm>
#include <sstream>
#include <stdarg.h>
#include <vector>
#include <stdio.h>
#include <assert.h>
#include <map>
#include <vector>

/*

inline std::string tolower(const std::string& s)
{
  std::string trans = s;

  for (std::string::iterator i=trans.begin(), end=trans.end(); i!=end; ++i)
    *i = ::tolower(*i);
  return trans;
}

std::string format(const char* fmt, ...) {
  va_list args;
  va_start(args, fmt);
  char	temp[2048];
  vsprintf(temp,fmt, args);
  std::string result = temp;
  va_end(args);
  return result;
}

std::vector<std::string> tokenize(const std::string& in, const std::string &delims, const int maxTokens, const bool useQuotes){
  std::vector<std::string> tokens;
  int numTokens = 0;
  bool inQuote = false;

  std::ostringstream currentToken;

  std::string::size_type pos = in.find_first_not_of(delims);
  int currentChar  = (pos == std::string::npos) ? -1 : in[pos];
  bool enoughTokens = (maxTokens && (numTokens >= (maxTokens-1)));

  while (pos != std::string::npos && !enoughTokens) {

    // get next token
    bool tokenDone = false;
    bool foundSlash = false;

    currentChar = (pos < in.size()) ? in[pos] : -1;
    while ((currentChar != -1) && !tokenDone){

      tokenDone = false;

      if (delims.find(currentChar) != std::string::npos && !inQuote) { // currentChar is a delim
	pos ++;
	break; // breaks out of while loop
      }

      if (!useQuotes){
	currentToken << char(currentChar);
      } else {

	switch (currentChar){
	  case '\\' : // found a backslash
	    if (foundSlash){
	      currentToken << char(currentChar);
	      foundSlash = false;
	    } else {
	      foundSlash = true;
	    }
	    break;
	  case '\"' : // found a quote
	    if (foundSlash){ // found \"
	      currentToken << char(currentChar);
	      foundSlash = false;
	    } else { // found unescaped "
	      if (inQuote){ // exiting a quote
		// finish off current token
		tokenDone = true;
		inQuote = false;
		//slurp off one additional delimeter if possible
		if (pos+1 < in.size() &&
		    delims.find(in[pos+1]) != std::string::npos) {
		  pos++;
		}

	      } else { // entering a quote
		// finish off current token
		tokenDone = true;
		inQuote = true;
	      }
	    }
	    break;
	  default:
	    if (foundSlash){ // don't care about slashes except for above cases
	      currentToken << '\\';
	      foundSlash = false;
	    }
	    currentToken << char(currentChar);
	    break;
	}
      }

      pos++;
      currentChar = (pos < in.size()) ? in[pos] : -1;
    } // end of getting a Token

    if (currentToken.str().size() > 0){ // if the token is something add to list
      tokens.push_back(currentToken.str());
      currentToken.str("");
      numTokens ++;
    }

    enoughTokens = (maxTokens && (numTokens >= (maxTokens-1)));
    if (enoughTokens){
      break;
    } else{
      pos = in.find_first_not_of(delims,pos);
    }

  } // end of getting all tokens -- either EOL or max tokens reached

  if (enoughTokens && pos != std::string::npos) {
    std::string lastToken = in.substr(pos);
    if (lastToken.size() > 0)
      tokens.push_back(lastToken);
  }

  return tokens;
}*/

BZ_GET_PLUGIN_VERSION

// event handler callback

class start : public bz_EventHandler
{
public:
  virtual void	process ( bz_EventData *eventData );
};
class playerPause : public bz_EventHandler
{
public:
  virtual void	process ( bz_EventData *eventData );
};
class stop : public bz_EventHandler
{
public:
  virtual void	process ( bz_EventData *eventData );
};

class schuss : public bz_EventHandler
{
public:
  virtual void	process ( bz_EventData *eventData );
};

class die : public bz_EventHandler
{
public:
  virtual void	process ( bz_EventData *eventData );
};
class kick : public bz_EventHandler
{
public:
  virtual void	process ( bz_EventData *eventData );
};

class ban : public bz_EventHandler
{
public:
  virtual void	process ( bz_EventData *eventData );
};

class join : public bz_EventHandler
{
public:
  virtual void	process ( bz_EventData *eventData );
};

//bz_CustomSlashCommandHandler



class LastChatCommand : public bz_CustomSlashCommandHandler
{
public:
  virtual ~LastChatCommand(){};
  virtual bool handle ( int playerID, bzApiString command, bzApiString message, bzAPIStringList *param );
};

////////////////////////////////////
int isstartg = 0;
int Userpause[999];
int pausecount = 0;
int lol1;
int lol2;


start	start;
stop	stop;
playerPause	playerPause;
schuss	schuss;
die	die;
kick	kick;
ban	ban;
join join;
LastChatCommand lastChatCommand;

/*
makepause	makepause;
makeresume	makeresume;
*/
BZF_PLUGIN_CALL int bz_Load ( const char* commandLine )
{
  bz_debugMessage(4,"Auto Paused plugin loaded");

 
  bz_registerCustomSlashCommand("pause",&lastChatCommand);
  bz_registerCustomSlashCommand("resume",&lastChatCommand);
//  bz_registerCustomSlashCommand("start",&lastChatCommand);

  bz_registerEvent(bz_ePlayerJoinEvent,&join);
  bz_registerEvent(bz_eGameStartEvent,&start);
  bz_registerEvent(bz_ePlayerPausedEvent,&playerPause);
  bz_registerEvent(bz_eGameEndEvent,&stop);
  bz_registerEvent(bz_eShotFiredEvent,&schuss);
  bz_registerEvent(bz_ePlayerDieEvent,&die);
  bz_registerEvent(bz_eKickEvent,&kick);
  bz_registerEvent(bz_eBanEvent,&ban);
  std::string param = commandLine;

  if (param == "usevictim")
	  bz_debugMessage(0,"Auto Paused plugin no longer takes any paramaters");
  return 0;
}

BZF_PLUGIN_CALL int bz_Unload ( void )
{

bz_removeCustomSlashCommand("pause");
bz_removeCustomSlashCommand("resume");
//bz_removeCustomSlashCommand("start");

  bz_removeEvent(bz_ePlayerJoinEvent,&join);
  bz_removeEvent(bz_eGameStartEvent,&start);
  bz_removeEvent(bz_ePlayerPausedEvent,&playerPause);
  bz_removeEvent(bz_eGameEndEvent,&stop);
  bz_removeEvent(bz_ePlayerDieEvent,&die);
  bz_removeEvent(bz_eShotFiredEvent,&schuss);
  bz_removeEvent(bz_eKickEvent,&kick);
  bz_removeEvent(bz_eBanEvent,&ban);
  bz_debugMessage(4,"Auto Paused plugin unloaded");
  return 0;
}



///////////////////////////////////////////////////////
// commands


bool LastChatCommand::handle ( int playerID, bzApiString _command, bzApiString _message, bzAPIStringList * /*_param*/ )
{
  std::string command = _command.c_str();
  std::string message = _message.c_str();


  bz_PlayerRecord *fromPlayer = bz_getPlayerByIndex(playerID);

   // std::vector<std::string> params = tokenize(message,std::string(" "),1,false);


/////////////////////////////////

std::string killerCallSign = "Server";
bz_PlayerRecord	*killerData;

killerData = bz_getPlayerByIndex(playerID);
if (killerData)
 killerCallSign = killerData->callsign.c_str();

std::string messageh;

messageh = std::string("")+ killerCallSign + std::string("");

//std::string killerCallSign = fromPlayer->callsign.c_str();


/////////////////////////////////

/*
if ( command == "start")
  {

if ( params.size() == 0)bz_startCountdown(10,1800,messageh.c_str());
if ( params.size() == 1){
	
	bz_startCountdown(params[1],1800,messageh.c_str());
}
if ( params.size() == 2){
	
	bz_startCountdown(params[1],params[2],messageh.c_str());
}
if ( params.size() > 2){
	bz_sendTextMessage(BZ_SERVER, playerID,"/start <countdown> <duration> ");
}

return true;
  }
*/
  if ( command == "resume")
  {
    if(isstartg != 0){
bz_resumeCountdown(messageh.c_str());
pausecount=0;
bz_setBZDBDouble("_tankSpeed",25.0);
bz_setBZDBDouble("_shotSpeed",100.0);
bz_setBZDBDouble("_jumpVelocity",19.0);
bz_setBZDBDouble("_tankAngVel",0.785398);
} else {
bz_sendTextMessage(BZ_SERVER, playerID,"No Game runing!");
	}
    return true;
  }

  if ( command == "pause")
  {
 if(isstartg != 0){
bz_pauseCountdown(messageh.c_str());
pausecount=pausecount+1;
bz_setBZDBDouble("_tankSpeed",0.000001);
bz_setBZDBDouble("_shotSpeed",0.0);
bz_setBZDBDouble("_jumpVelocity",0.0);
bz_setBZDBDouble("_tankAngVel",0.000001);
	} else {
bz_sendTextMessage(BZ_SERVER, playerID,"No Game runing!");
	}
    return true;
  }
  
  return false;
}


///////////////////////////////////////////////////
//JOIN
void join::process( bz_EventData *eventData ){

std::string soundToPlay;
  if (eventData->eventType != bz_ePlayerJoinEvent)
    return;
bz_PlayerJoinPartEventData *joinData = (bz_PlayerJoinPartEventData*)eventData;

bz_sendTextMessage(BZ_SERVER,joinData->playerID,"     Auto Paused Plugin is loaded.     ");
bz_sendTextMessage(BZ_SERVER,joinData->playerID,"Use /countdown <sec>  to start  a game.");
bz_sendTextMessage(BZ_SERVER,joinData->playerID,"Use /pause            to Paused a game.");
bz_sendTextMessage(BZ_SERVER,joinData->playerID,"Use /resume           to Resume a game.");
bz_sendTextMessage(BZ_SERVER,joinData->playerID,"      Auto Pause is make by Links      ");

Userpause[joinData->playerID] = 0; 
}
///////////////////////////////////////////////////
//BAN
void ban::process( bz_EventData *eventData ){

std::string soundToPlay;
  if (eventData->eventType != bz_eBanEvent)
    return;

bz_BanEventData *BanData = (bz_BanEventData*)eventData;



if(Userpause[BanData->banneeID] == 1){ 
Userpause[BanData->banneeID] = 0; 
pausecount=pausecount-1;
}

///////////
std::string killerCallSign = "UNKNOWN";
bz_PlayerRecord	*killerData;

killerData = bz_getPlayerByIndex(BanData->banneeID);
if (killerData)
 killerCallSign = killerData->callsign.c_str();

std::string message;

message = std::string("Player ")+ killerCallSign + std::string(" Baned!");
bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS,message.c_str());
///////////

if(pausecount == 0){
/////////////////////////////////
bz_setBZDBDouble("_tankSpeed",25.0);
bz_setBZDBDouble("_shotSpeed",100.0);
bz_setBZDBDouble("_jumpVelocity",19.0);
bz_setBZDBDouble("_tankAngVel",0.785398);
/////////////////////////////////
bz_resumeCountdown("Server");

}

}
///////////////////////////////////////////////////
//Kick
void kick::process( bz_EventData *eventData ){

std::string soundToPlay;
  if (eventData->eventType != bz_eKickEvent)
    return;

bz_KickEventData *kickData = (bz_KickEventData*)eventData;

if(Userpause[kickData->kickedID] == 1){ 
Userpause[kickData->kickedID] = 0; 
pausecount=pausecount-1;
}

///////////
std::string killerCallSign = "UNKNOWN";
bz_PlayerRecord	*killerData;

killerData = bz_getPlayerByIndex(kickData->kickedID);
if (killerData)
 killerCallSign = killerData->callsign.c_str();

std::string message;

message = std::string("Player ")+ killerCallSign + std::string(" Kicked!");
bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS,message.c_str());
///////////
if(pausecount == 0){
/////////////////////////////////
bz_setBZDBDouble("_tankSpeed",25.0);
bz_setBZDBDouble("_shotSpeed",100.0);
bz_setBZDBDouble("_jumpVelocity",19.0);
bz_setBZDBDouble("_tankAngVel",0.785398);
/////////////////////////////////
bz_resumeCountdown("Server");

}
}
///////////////////////////////////////////////////
//DIE
void die::process( bz_EventData *eventData ){
std::string soundToPlay;
  if (eventData->eventType != bz_ePlayerDieEvent)
    return;
bz_PlayerDieEventData *dieData = (bz_PlayerDieEventData*)eventData;

if(pausecount != 0){
int playerToUse = BZ_SERVER;
///////////////////////////////////
std::string killerCallSign = "UNKNOWN";
bz_PlayerRecord	*killerData;

killerData = bz_getPlayerByIndex(dieData->killerID);
if (killerData)
 killerCallSign = killerData->callsign.c_str();

std::string message;

message = std::string("Player ")+ killerCallSign + std::string(" do kill a Player! DO not kill!!!!!!");
bz_killPlayer(dieData->killerID,true,dieData->playerID);
bz_sendPlayCustomLocalSound ( dieData->killerID, "killteam" );
//bz_sendTextMessage(playerToUse, joinData->playerID,message.c_str());

//bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS,"Player Paused!! Do not Play !!!");
bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS,message.c_str());

///////////////////////////////


}

}
///////////////////////////////////////////////////
//shot
void schuss::process( bz_EventData *eventData ){
std::string soundToPlay;
  if (eventData->eventType != bz_eShotFiredEvent)
    return;

bz_ShotFiredEventData *FiredData = (bz_ShotFiredEventData*)eventData;

if(pausecount != 0){
  int playerToUse = BZ_SERVER;

 // Kill the player when he shote!
 /*

 float reloadTime = (float)bz_getBZDBDouble("_reloadTime");

 if (bz_BZDBItemExists("_swDeathReloadFactor") && bz_getBZDBDouble("_swDeathReloadFactor") > 0)
 reloadTime *= (float)bz_getBZDBDouble("_swDeathReloadFactor");

bz_fireWorldWep("SW",reloadTime,playerToUse,FiredData->pos,0,0,0,0.0f);
*/
bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS,"Player Paused!! Do not Play !!!");
}


}
///////////////////////////////////////////////////
//End Game
void stop::process( bz_EventData *eventData ){
std::string soundToPlay;
  if (eventData->eventType != bz_eGameEndEvent)
    return;

   // bz_resetTeamScores();
	bz_resetFlags(true);
isstartg = 0;

}

///////////////////////////////////////////////////
//Start Game
void start::process( bz_EventData *eventData ){
std::string soundToPlay;
  if (eventData->eventType != bz_eGameStartEvent)
    return;
  	//bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, " ");
	//bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, "Have fun! Do not Cheat!");
	//bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, "Good Luck!");
    bz_resetTeamScores();
	bz_resetFlags(true);
	bz_setBZDBDouble("_tankSpeed",25.0);
	bz_setBZDBDouble("_tankAngVel",0.785398);
    bz_setBZDBDouble("_shotSpeed",100.0);
    bz_setBZDBDouble("_jumpVelocity",19.0);
isstartg = 1;
}

///////////////////////////////////////////////////
//player go pause
void playerPause::process(bz_EventData *eventData)
{
	std::string soundToPlay;
  if (eventData->eventType != bz_ePlayerPausedEvent)
    return;

bz_GameStartEndEventData *gameData = (bz_GameStartEndEventData*)eventData;
bz_PlayerPausedEventData *pauseData = (bz_PlayerPausedEventData*)eventData;


if(isstartg == 1){

std::string killerCallSign = "UNKNOWN";
bz_PlayerRecord	*killerData;

killerData = bz_getPlayerByIndex(pauseData->player);
if (killerData)
 killerCallSign = killerData->callsign.c_str();

std::string message;

if(Userpause[pauseData->player] == 0){ Userpause[pauseData->player] = 1; 
message = std::string("Player ")+ killerCallSign + std::string(" go pause! Game Paused!");
//bz_sendTextMessage(playerToUse, joinData->playerID,message.c_str());


bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS,message.c_str());
/////////////////////////////////
bz_setBZDBDouble("_tankSpeed",0.000001);
bz_setBZDBDouble("_shotSpeed",0.0);
bz_setBZDBDouble("_jumpVelocity",0.0);
bz_setBZDBDouble("_tankAngVel",0.000001);
/////////////////////////////////
bz_pauseCountdown("Server");
pausecount=pausecount+1;
} else {
pausecount=pausecount-1;
if(pausecount == 0){
message = std::string("Player ")+ killerCallSign + std::string(" is Resume! Game Resume!");
//bz_sendTextMessage(playerToUse, joinData->playerID,message.c_str());


bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS,message.c_str());
/////////////////////////////////
bz_setBZDBDouble("_tankSpeed",25.0);
bz_setBZDBDouble("_shotSpeed",100.0);
bz_setBZDBDouble("_tankAngVel",0.785398);
bz_setBZDBDouble("_jumpVelocity",19.0);
/////////////////////////////////
bz_resumeCountdown("Server");

Userpause[pauseData->player] = 0;

} else {
	message = std::string("Player ")+ killerCallSign + std::string(" is Resume! ");
//bz_sendTextMessage(playerToUse, joinData->playerID,message.c_str());


bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS,message.c_str());
Userpause[pauseData->player] = 0;

}
}

}

}

// Local Variables: ***
// mode:C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8

